use std::io::{self, Read};

use crate::util::print_packet;

use self::{demod::Demod, parse::LeF32Decoder};

mod demod;
mod packet;
mod parse;

trait Bit {
    fn bit(&self) -> bool;
}

impl Bit for f32 {
    fn bit(&self) -> bool {
        *self < 0.0
    }
}

pub fn decode_forever() {
    let stdin = io::stdin();
    let soft_bits = LeF32Decoder::new(stdin.bytes().map(|x| x.expect("Could not read from stdin")));
    let demod = Demod::new(soft_bits);

    demod.demod(|p| {
        print_packet(&p);
    });
}
