use crate::felinet::{handler_client::HandlerClient, PacketIn as SemiPacketIn};
use async_stream::stream;
use std::time::Duration;
use tokio::sync::broadcast;
use tonic::{transport::Channel, Request};

pub async fn felinet_send_forever(
    mut client: HandlerClient<Channel>,
    tx: broadcast::Sender<SemiPacketIn>,
) {
    loop {
        let mut rx = tx.subscribe();
        let felinet_stream = stream! {
            loop {
                yield rx.recv().await.expect("Channel closed");
            }
        };

        if let Err(e) = client.push_packets(Request::new(felinet_stream)).await {
            eprintln!("FELINET TX error: {e}. Reconnecting...");
        };

        tokio::time::sleep(Duration::from_secs(1)).await;
    }
}
